function [p,w] = interpola2( x, y, X, Y)

% Clipping:
x = max(x,1); x = min( x, X );
y = max(y,1); y = min( y, Y );
                            
% Upper and lower bounds:
xl = floor(x); yl = floor(y); 
xu = ceil(x);  yu = ceil(y);

% Check integer indices:
xu(xu==xl) = xu(xu==xl) + 1;
yu(yu==yl) = yu(yu==yl) + 1;

% Compute weights:
wxu = x-xl; wyu = y-yl;
wxl = xu-x; wyl = yu-y;
                            
% Check out-of-bounds indices:
xu(xu>X) = X;
yu(yu>Y) = Y;

% Find pointers and weights:
p(:,1) = yl + Y.*(xl-1);
w(:,1) = wyl.*wxl;
p(:,2) = yl + Y.*(xu-1);
w(:,2) = wyl.*wxu;
p(:,3) = yu + Y.*(xl-1);
w(:,3) = wyu.*wxl;
p(:,4) = yu + Y.*(xu-1);
w(:,4) = wyu.*wxu;



return