function [Soi ref DefF]=motion_sim(So,tmove,flag,refb,defF);

%=============================================================
% FUNCTION MOTION_SIM
%
% Simulate the motion due to breathing
%
% INPUT
%	So:	original image
%	tmove:	amount of movement [1-5]
%	flag:   if==0 Creates random movement
%		if==1 uses the deformation field defined in refb and defF
%	refb:	deformation (only nedded if flag==1)
%	defF:	deformation for mask (only nedded if flag==1)


[Mx My]=size(So);
if flag==0
	ref=round(2.*tmove.*rand(3)-tmove);
%CREATE DEFORMATION FIELD--------
	T1=(1:My)-My/2;
	T1=repmat(T1,[Mx,1]); 
	T2=(1:Mx)-Mx/2;              
	T2=repmat(T2',[1,My]);
	Tt(:,:,1)=T1;
	Tt(:,:,2)=T2;
	DefF=tmove.*sign(randn(1)).*Tt./max(Tt(:))./2;
else
	ref=refb;
	DefF=defF;
end
	Sbig=periodic_sg(So);
        Sr=(imrotate(Sbig,ref(1),'crop'));
    	Soi=Sr(Mx+ref(2)+(1:Mx),My+ref(3)+(1:My));
	Soi = mydeform(Soi,DefF,flag);
